# 2021-03-07 @ BLR
#
########################################
#
# DEFINITION OF FILES AND VARIABLES
#
##########
#
#     LOG FILE : filogname
#                filog
#
#   INPUT FILE : inputfilename             [.res format (shlx)]
#                inputfilename_noextension
#
#  OUTPUT FILE :  outputfilename
#                 filoutangle_res   [.res format (shlx)]
#                 filoutangle_gsa   [.gsa format (gsas)]
#
##########
#
# DATE AND TIME : starttime
#                 stoptime
#
##########
#
# DIAGNOSTICS : flag_diag
#
##########
#
# PYTHON LISTS
#
# headersuperatomlist = []
#   tailsuperatomlist = []
#       superatomlist = []
# headershlxfile      = []
#
# CELL    = []
# SPECIES = []
# NUMBER  = []
#
# movingatomlist = []
#
##########
#
# PYTHON DICTIONARIES
#
# dictionary_element = {}
#
##########
#
# PYTHON ARRAYS
#
#       superatomarray = np.array(superatomlist)
# headersuperatomarray = np.array(headersuperatomlist
#
# GMT       !  G Metric Tensor
# g11 , g12 , g13 , g21 , g22 , g23 , g31 , g32 , g33
#
# RGMT      ! Reciprocal RG Metric Tensor
#
#
##########
#
# PYTHON VARIABLES
#
# atom_number
#
# a       ! A
# b       ! A
# c       !
# alpha   ! degrees
# beta    ! degrees
# gamma   ! degrees
# alphar  ! radians
# betar   ! radians
# gammar  ! radians
#
# volume  ! AAA
#
# stringmovingatomlist = ''
# movingatomnumber = 0
# addmovingatom = True
#
##########
#
# PYTHON CONSTANTS
#
# dectorad
#
##########
#
import matplotlib.pyplot as plt
import numpy as np
import datetime
#
np.set_printoptions(suppress=True,precision=6)
#
spacer = ' '
#
# OPEN LOG    FILE [.LOG]
filogname = 'rotate_fragment_v163.log'  #         name of the file
filog     = open(filogname,'w')         # logical name of the file
#
# SET DATE AND TIME
starttime = str(datetime.datetime.now())[:19]  # truncated after 20 characters ...
print()
print(starttime)
print()
#
filog.write(            '\n')
filog.write(starttime + '\n')
filog.write(            '\n')
#
#
# FRONT-END HEADER
print()
print(' **************************************************************************** ')
print(' *                                                                          * ')
print(' * WELCOME ... to our software ... ROTATE_FRAGMENT ... [v 163 - 2021-03-07] * ')
print(' *                                                                          * ')
print(' **************************************************************************** ')
print(' *                                                                          * ')
print(' * Written by ... Robert J PAPOULAR ... [IRAMIS, DRF , CEA-Saclay , France] * ')
print(' *                                                                          * ')
print(' **************************************************************************** ')
print(' *                                                                          * ')
print(' *                         Robert.Papoular@cea.fr                           * ')
print(' *                                                                          * ')
print(' **************************************************************************** ')
print()
#

filog.write(                                                                                   '\n')
filog.write(' **************************************************************************** ' + '\n')
filog.write(' *                                                                          * ' + '\n')
filog.write(' * WELCOME ... to our software ... ROTATE_FRAGMENT ... [v 163 - 2021-03-07] * ' + '\n')
filog.write(' *                                                                          * ' + '\n')
filog.write(' **************************************************************************** ' + '\n')
filog.write(' *                                                                          * ' + '\n')
filog.write(' * Written by ... Robert J PAPOULAR ... [IRAMIS, DRF , CEA-Saclay , France] * ' + '\n')
filog.write(' *                                                                          * ' + '\n')
filog.write(' **************************************************************************** ' + '\n')
filog.write(' *                                                                          * ' + '\n')
filog.write(' *                         Robert.Papoular@cea.fr                           * ' + '\n')
filog.write(' *                                                                          * ' + '\n')
filog.write(' **************************************************************************** ' + '\n')
filog.write(                                                                                   '\n')
#
#
flag_diag=''
while((flag_diag != 'Y') and (flag_diag != 'N')):
  flag_diag = input('DIAGNOSTICS ON / OFF ... [ Y / N ] ... ? ')
  if(flag_diag == 'Y'):
    print()
    print('DIAGNOSTICS ARE ON !')
    print()
    filog.write('\n')
    filog.write('DIAGNOSTICS ARE ON ! \n')
  elif(flag_diag == 'N'):
    print()
    print('DIAGNOSTICS ARE OFF !')
    print()
    filog.write('\n')
    filog.write('DIAGNOSTICS ARE OFF ! \n')                

#
print()
#      12345678901234567890123456789012345678901234567890123456789012345678901234567890
#      1        1         2         3         4         5         6         7         8
#               0         0         0         0         0         0         0         0
print('********************************************************************************')
print()
print('*************************************')
print('*                                   *')
print('* PART I : READ A SHELX [.RES] FILE *')
print('*                                   *')
print('*************************************')
print()
#
filog.write('\n')
filog.write('*************************************' + '\n')
filog.write('*                                   *' + '\n')
filog.write('* PART I : READ A SHELX [.RES] FILE *' + '\n')
filog.write('*                                   *' + '\n')
filog.write('*************************************' + '\n')
filog.write('\n')
#
#########################################################################################################################
#                                                                                                                       #
# PART I : READ A SHELX.RES FILE                                                                                        #
#                                                                                                                       #
inputfilename = input(' [SHELX .RES] FILE NAME ... [with .EXT] ... ? ')
print()
print('INPUT FILE :')
print(inputfilename)
print()
#
filog.write('INPUT FILE : ' + '\n')
filog.write(inputfilename   + '\n')
filog.write('\n')

#
inputfilename_extposition = inputfilename.rfind('.')
inputfilename_noextension = inputfilename[:inputfilename_extposition]
#
print('OUTPUT FILE :')
print(filogname)
print()
#
filog.write('OUTPUT FILE : ' + '\n')
filog.write(filogname         + '\n')
filog.write(                    '\n')
#

filin      = open( inputfilename,'r')
#
dictionary_element = {}
#
line_number_header = 0 # initialization
line_number = 0        # initialization
line_empty = False     # initialization
atom_number = 0        # initialization
#
headersuperatomlist = []
tailsuperatomlist   = []
#
superatomlist       = []
#
headershlxfile      = []
#
print()
while (line_empty==False):
  line = filin.readline()
  print(line)
  if(len(line)==0):
    line_empty = True
  #
  line_number = line_number + 1
  #
  header1=line[:4]
  header2=line[:3]
  header3=line[:5]                               # Up to 999 unique atoms (proteins)
  header4=line[5:]
  print(header1)
  if(header1=='TITL'):
    filog.write(line)
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
  elif(header1=='CELL'):
    filog.write(line)
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
    #
    # Read LATTICE PARAMETERS
    line_CELL = line[4:]
    CELL = []
    for parameter in line_CELL.split():
      CELL.append(float(parameter))
    #
    print()
    print('    ' + line_CELL)
    print(CELL)
    print()
    #
    wl    = CELL[0]
    a     = CELL[1]
    b     = CELL[2]
    c     = CELL[3]
    alpha = CELL[4]
    beta  = CELL[5]
    gamma = CELL[6]
    #
    print('     wavelength [A] = % 10.5f' %(wl))
    print('     a = % 10.5f b = % 10.5f c = % 10.5f alpha = % 10.5f beta = % 10.5f gamma = % 10.5f' %(a,b,c,alpha,beta,gamma))
    print()
  elif(header1=='ZERR'):
    filog.write(line)
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
  elif(header1=='LATT'):
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
  elif(header1=='SYMM'):
    filog.write(line)
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
  elif(header1=='SFAC'):
    filog.write(line)
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
    line_SPECIES = line[4:]
    SPECIES = []
    NUMBER  = []
    species_number = 0
    for specie in line_SPECIES.split():
      species_number = species_number + 1
      SPECIES.append(specie)
      NUMBER.append(species_number)
    #
    print()
    print('    Number of atom species : % 2d' %(species_number))
    print()
    #
    print(NUMBER)
    print(SPECIES)
    #
    TABLE_I = [ NUMBER , SPECIES ]
    #
    print()
    print(TABLE_I)
    #
    filog.write(                              '\n')
    filog.write('NUMBER  : ' + str(NUMBER)  + '\n')
    filog.write('SPECIES : ' + str(SPECIES) + '\n')
    filog.write('TABLE I : ' + str(TABLE_I) + '\n')
    filog.write(                              '\n')
    #
  elif(header1=='UNIT'):
    filog.write(line)
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
  elif(header1=='FVAR'):
    filog.write(line)
    line_number_header = line_number_header + 1
    headershlxfile.append(line)
    #
    print()
    print('==========================================================')
    print()
  elif(header2=='END'):
    line_empty = True
  else:
    atom_number = atom_number + 1
    print('atom number: % 3d' %(atom_number))
    filog.write(line)
    #
    truncline = line[4:]
    atomline = []
    parameternumber = 0
    for parameter in truncline.split():
      atomline.append(float(parameter))
      parameternumber = parameternumber + 1
      print(parameternumber)
    #  
    print()
    print(atomline)
    print()
    print('==========================================================')
    print()
    #
    superatomlist.append(atomline)  # list of lists   (LOL)
    print(superatomlist)            # attempt to print LOL
    print()
    superatomarray = np.array(superatomlist)
    print(superatomarray)
    print()
    #
    headersuperatomlist.append(header3)
    print(headersuperatomlist)
    print()
    print()
    headersuperatomarray = np.array(headersuperatomlist)
    print(headersuperatomarray)
    print()
    #
    tailsuperatomlist.append(header4)
    print(tailsuperatomlist)
    print()
    #
    print()
    print(headershlxfile)
    print()
#
filog.write('\n')
filog.write(str(superatomlist))
filog.write('\n')
filog.write('\n')
filog.write(str(headersuperatomlist))
filog.write('\n')
filog.write('\n')
filog.write(str(tailsuperatomlist))
filog.write('\n')
filog.write('\n')
filog.write(str(headershlxfile))
filog.write('\n')
filog.write('\n')

atom_numberp1 = atom_number + 1

print()
print('Number of lines in the file          ... : % 3d ' %(line_number))
print()
print('Number of lines in the header        ... : % 3d ' %(line_number_header))
print()
print('Number of atoms in the file          ... : % 3d ' %(atom_number))
print()
print('Number of atomic species in the file ... : % 3d ' %(species_number))
print()
#
filog.write('\n')
filog.write('Number of lines in the file          ... : % 3d ' %(line_number))
filog.write('\n')
filog.write('Number of lines in the header        ... : % 3d ' %(line_number_header))
filog.write('\n')
filog.write('Number of atoms in the file          ... : % 3d ' %(atom_number))
filog.write('\n')
filog.write('Number of atomic species in the file ... : % 3d ' %(species_number))
filog.write('\n')
#                                                                                                                       #
# END OF PART I : READ A SHELX.RES FILE                                                                                 #
#                                                                                                                       #
#########################################################################################################################
#
#
print()
print()
#      12345678901234567890123456789012345678901234567890123456789012345678901234567890
#      1        1         2         3         4         5         6         7         8
#               0         0         0         0         0         0         0         0
print('********************************************************************************')
print()
print('***********************************************************')
print('*                                                         *')
print('* PART II : UNIT CELL - METRIC TENSOR - RECIPROCAL TENSOR *')
print('*                                                         *')
print('***********************************************************')
print()
#
filog.write('\n')
filog.write('\n')
filog.write('***********************************************************' + '\n')
filog.write('*                                                         *' + '\n')
filog.write('* PART II : UNIT CELL - METRIC TENSOR - RECIPROCAL TENSOR *' + '\n')
filog.write('*                                                         *' + '\n')
filog.write('***********************************************************' + '\n')
filog.write('\n')
#
#########################################################################################################################
#                                                                                                                       #
# PART II : UNIT CELL - METRIC TENSOR - RECIPROCAL TENSOR                                                               #
#                                                                                                                       #
degtorad = np.pi/180.0
#
alphar = alpha * degtorad           # r is for ... radian
betar  = beta  * degtorad
gammar = gamma * degtorad
#
#
#####################################################################################
#                                                                                   #
# COMPUTE METRIC TENSOR
g11 = a*a
g21 = b*a*np.cos(gammar)
g31 = c*a*np.cos(betar )
g12 = g21
g22 = b*b
g32 = c*b*np.cos(alphar)
g13 = g31
g23 = g32
g33 = c*c
#
GMT = np.array([[g11,g12,g13],[g21,g22,g23],[g31,g32,g33]])
#
#
print(                                                            )
print('METRIC TENSOR'                                             )
print(                                                            )
print('% 12.5f , % 12.5f , % 12.5f' %(GMT[0][0],GMT[0][1],GMT[0][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(GMT[1][0],GMT[1][1],GMT[1][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(GMT[2][0],GMT[2][1],GMT[2][2]))
print(                                                            )
#
filog.write(                          '\n'                                 )
filog.write('METRIC TENSOR' +         '\n'                                 )
filog.write('                          \n'                                 )
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(GMT[0][0],GMT[0][1],GMT[0][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(GMT[1][0],GMT[1][1],GMT[1][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(GMT[2][0],GMT[2][1],GMT[2][2]))
filog.write('                          \n'                                 )
#
# COMPUTE RECIPROCAL METRIC TENSOR
#
RGMT = np.linalg.inv(GMT)
#
#
print(                                                               )
print('RECIPROCAL METRIC TENSOR'                                     )
print(                                                               )
print('% 12.5f , % 12.5f , % 12.5f' %(RGMT[0][0],RGMT[0][1],RGMT[0][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(RGMT[1][0],RGMT[1][1],RGMT[1][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(RGMT[2][0],RGMT[2][1],RGMT[2][2]))
print(                                                               )
#
filog.write(                             '\n')
filog.write('RECIPROCAL METRIC TENSOR' + '\n')
filog.write(                             '\n')
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(RGMT[0][0],RGMT[0][1],RGMT[0][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(RGMT[1][0],RGMT[1][1],RGMT[1][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(RGMT[2][0],RGMT[2][1],RGMT[2][2]))
filog.write(                             '\n')
#
# CHECK ... GMT * RGMT = I !
check1 = np.dot(GMT,RGMT)
check2 = np.dot(RGMT,GMT)
#
print()
print('THE MATRIX BELOW SHOULD BE UNITY ... =  GMT * RGMT')
print()
print('% 12.5f , % 12.5f , % 12.5f' %(check1[0][0],check1[0][1],check1[0][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(check1[1][0],check1[1][1],check1[1][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(check1[2][0],check1[2][1],check1[2][2]))
print()
#
filog.write('\n')
filog.write('THE MATRIX BELOW SHOULD BE UNITY ... =  GMT * RGMT' + '\n')
filog.write('\n')
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(check1[0][0],check1[0][1],check1[0][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(check1[1][0],check1[1][1],check1[1][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(check1[2][0],check1[2][1],check1[2][2]))
filog.write('\n')
#
#
print()
print('THE MATRIX BELOW SHOULD BE UNITY ... = RGMT *  GMT')
print()
print('% 12.5f , % 12.5f , % 12.5f' %(check2[0][0],check2[0][1],check2[0][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(check2[1][0],check2[1][1],check2[1][2]))
print('% 12.5f , % 12.5f , % 12.5f' %(check2[2][0],check2[2][1],check2[2][2]))
print()
#
filog.write('\n')
filog.write('THE MATRIX BELOW SHOULD BE UNITY ... = RGMT *  GMT' + '\n')
filog.write('\n')
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(check2[0][0],check2[0][1],check2[0][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(check2[1][0],check2[1][1],check2[1][2]))
filog.write('% 12.5f , % 12.5f , % 12.5f \n' %(check2[2][0],check2[2][1],check2[2][2]))
filog.write('\n')
#                                                                                   #
#####################################################################################
#
volume =          GMT[0][0]*GMT[1][1]*GMT[2][2] + GMT[0][1]*GMT[1][2]*GMT[2][0] + GMT[0][2]*GMT[2][1]*GMT[1][0]
volume = volume - GMT[0][0]*GMT[1][2]*GMT[2][1] - GMT[1][1]*GMT[0][2]*GMT[2][0] - GMT[2][2]*GMT[0][1]*GMT[1][0]
volume = np.sqrt(volume)
#
print()
print('VOLUME OF THE UNIT CELL ... [Angstroems] ... = % 12.5f' %(volume))
print()
#
filog.write('\n')
filog.write(' VOLUME OF THE UNIT CELL ... [Angstroems] ... = % 12.5f' %(volume))
filog.write('\n')
#                                                                                                                       #
# END OF PART II : UNIT CELL - METRIC TENSOR - RECIPROCAL TENSOR - UNIT CELL VOLUME                                     #
#                                                                                                                       #
#########################################################################################################################

#
print()
#      12345678901234567890123456789012345678901234567890123456789012345678901234567890
#      1        1         2         3         4         5         6         7         8
#               0         0         0         0         0         0         0         0
print('********************************************************************************')
print()
print()
print('*********************************')
print('*                               *')
print('* PART III : CREATE ATOM TABLES *')
print('*                               *')
print('*********************************')
print()
#
filog.write('\n')
filog.write('*********************************' + '\n')
filog.write('*                               *' + '\n')
filog.write('* PART III : CREATE ATOM TABLES *' + '\n')
filog.write('*                               *' + '\n')
filog.write('*********************************' + '\n')
filog.write('\n')
#
#########################################################################################################################
#                                                                                                                       #
# PART III : CREATE ATOM TABLES                                                                                         #
#                                                                                                                       #

# FIRSTLY, A SPECIES DICTIONARY
#
dictionary_species ={}
#
s_index = -1
for s in SPECIES:
  s_index = s_index + 1
  new_key   = str(NUMBER[s_index])
  new_value = SPECIES[s_index]
  dictionary_species[new_key] = new_value
#
print('ATOMIC SPECIES DICTIONARY :')
print()
print(dictionary_species)
print()
print()
#
filog.write('\n')
filog.write('ATOMIC SPECIES DICTIONARY :' + '\n')
filog.write('\n')
filog.write(str(dictionary_species))
filog.write('\n')
filog.write('\n')

# SECONDLY, LIST OF UNIQUE ATOMS TO MOVE ( by their number in the RES file )
#
print('DEFINE ATOMIC FRAGMENT :')
print()
#
#filog.write('\n')
#filog.write('DEFINE ATOMIC FRAGMENT :' + '\n')

movingatomlist = []
stringmovingatomlist = ''
#
movingatomseriesnumber = 0
movingatomnumber = 0
# addmovingatom = True
addmovingatomseries = True
#
while (addmovingatomseries==True):
  print()
  answer = input('New atom ... series ... to move ... [Y/N] ... ? ')
  if(answer=='N'):
    addmovingatomseries = False
  elif(answer=='Y'):
    movingatomseriesnumber = movingatomseriesnumber + 1
    new_atom_series_first  = int(input('[moving atom series % 3d] FIRST atom of new series to move ... [ integer ] ... ' %(movingatomseriesnumber)))
    new_atom_series_last   = int(input('[moving atom series % 3d] LAST  atom of new series to move ... [ integer ] ... ' %(movingatomseriesnumber)))
    #
    new_atom_series_lastp1 = new_atom_series_last + 1
    #
    atomalreadyinlist = False
    for new_atom in range(new_atom_series_first,new_atom_series_lastp1):
      # For each atom in the new series, check if the latter is already in the  moving_atom_list
      for atomnumber in movingatomlist:
        if(atomnumber==new_atom):
          # print()
          print('  This atom has already been included in the list ... ')
          # print()
          atomalreadyinlist = True
      # For each atom in the new series, if not already in the moving atom list
      if(atomalreadyinlist==False):
        movingatomnumber = movingatomnumber + 1   #  one more atom ... is moving
        movingatomlist.append(new_atom)           # it is appended to the list of moving atoms             
        if(movingatomnumber!=1):                  # if not the first atom to move , add a comma after the previous moving atom in the list of moving atoms
          stringmovingatomlist = stringmovingatomlist + ' , '
          stringmovingatomlist = stringmovingatomlist + str(new_atom)   # and then add the atom_number ( in the input .RES file )
          # print()
        else:
          stringmovingatomlist = stringmovingatomlist + str(new_atom)   # if it is the first atom, merely  add the atom_number ( in the input .RES file )
          # print()          
#
print()
print()
print('ATOMIC FRAGMENT :')
print()
print('Number of series of unique atoms to move : % 3d' %(movingatomseriesnumber))
print()
print('Number of unique atoms to move : % 3d' %(movingatomnumber))
print()
print('List   of unique atoms to move :  ')
print(movingatomlist)
print()
#
#filog.write('\n')
filog.write('\n')
filog.write('ATOMIC FRAGMENT :' + '\n')
filog.write('\n')
filog.write('Number of series of unique atoms to move : % 3d' %(movingatomseriesnumber))
filog.write('\n')
filog.write('Number of unique atoms to move : % 3d' %(movingatomnumber))
filog.write('\n')
filog.write('List   of unique atoms to move :  ')
filog.write(stringmovingatomlist)
filog.write('\n')

# THIRDLY, PAIR OF ( REAL OR DUMMY ) ATOMS WHICH DEFINES THE ( ORIENTED )ROTATION AXIS 
#
print()
print('DEFINE THE ORIENTED ROTATION AXIS WITH 2 ATOMS ... ')
print()
#
tail = input('First  atom number ... tail ... ')
tip  = input('Second atom number ... tip  ... ')
tailatomnumber = int(tail)
tipatomnumber  = int(tip)
print()
print('tail atom crystallographic coordinates : ')
print(superatomarray[tailatomnumber-1][1:4])
print()
print('tip  atom crystallographic coordinates : ')
print(superatomarray[tipatomnumber-1][1:4])

#
print()
print()
print('ORIENTED ROTATION AXIS :')
print()
print('rotation axis is defined by atoms % 2d and % 2d' %(tailatomnumber,tipatomnumber))
print()
print()
#
filog.write('\n')
filog.write('\n')
filog.write('ORIENTED ROTATION AXIS :' + '\n')
filog.write('\n')
filog.write('rotation axis is defined by atoms % 2d and % 2d' %(tailatomnumber,tipatomnumber))
filog.write('\n')
filog.write('\n')

#print()
#print()
print('ROTATION RANGE AND STEP :')
print()
print()
t_start,t_stop,t_step = input('[THETA(degrees)] START , STOP , STEP : ').split()
#
theta_start = float(t_start)
theta_stop  = float(t_stop)
theta_step  = float(t_step)
#
print()
print(theta_start,theta_stop,theta_step)
print()
print('ROTATION from % 6.2f to % 6.2f using a step of % 6.2f degrees' %(theta_start,theta_stop,theta_step))
print()
print()
#
filog.write('\n')
filog.write('ROTATION RANGE AND STEP :' + '\n')
filog.write('\n')
filog.write(t_start + ' ' + t_stop + ' ' + t_step + '\n')
filog.write('\n')
filog.write('ROTATION from % 6.2f to % 6.2f using a step of % 6.2f degrees \n' %(theta_start,theta_stop,theta_step))
filog.write('\n')
filog.write('\n')

#                                                                                                                       #
# END OF PART III : CREATE ATOM TABLES                                                                                  #
#                                                                                                                       #
#########################################################################################################################

#
print()
#      12345678901234567890123456789012345678901234567890123456789012345678901234567890
#      1        1         2         3         4         5         6         7         8
#               0         0         0         0         0         0         0         0
print('********************************************************************************')
print()
print('***********************************************************')
print('*                                                         *')
print('* PART IV : FUNCTION POINT_ROTATION                       *')
print('*                                                         *')
print('***********************************************************')
print()
#
filog.write('\n')
filog.write('***********************************************************' + '\n')
filog.write('*                                                         *' + '\n')
filog.write('* PART IV : FUNCTION POINT_ROTATION                       *' + '\n')
filog.write('*                                                         *' + '\n')
filog.write('***********************************************************' + '\n')
filog.write('\n')
#
#########################################################################################################################
#                                                                                                                       #
# PART IV : FUNCTION POINT_ROTATION                                                                                     #
#                                                                                                                       #
def triplet_sum( triplet_M , triplet_A , triplet_B ):
  #
  triplet_R = triplet_A + triplet_B + triplet_M
  #
  return triplet_R

def atomic_rotation( triplet_M , triplet_A , triplet_B , angle ):
  #
  # From triplet to crystallographic coordinates
  #
  xa = triplet_A[0]
  ya = triplet_A[1]
  za = triplet_A[2]
  #
  xb = triplet_B[0]
  yb = triplet_B[1]
  zb = triplet_B[2]
  #
  xm = triplet_M[0]
  ym = triplet_M[1]
  zm = triplet_M[2]
  #
  if(flag_diag == 'Y'):
    print()
    print('CHECK 1 - Triplet_A : % 10.5f % 10.5f % 10.5f \n' %(triplet_A[0],triplet_A[1],triplet_A[2])) 
    print('CHECK 1 - Triplet_B : % 10.5f % 10.5f % 10.5f \n' %(triplet_B[0],triplet_B[1],triplet_B[2])) 
    print('CHECK 1 - Triplet_M : % 10.5f % 10.5f % 10.5f \n' %(triplet_M[0],triplet_M[1],triplet_M[2]))
    #
    filog.write('\n')
    filog.write('CHECK 1 - Triplet_A : % 10.5f % 10.5f % 10.5f \n' %(triplet_A[0],triplet_A[1],triplet_A[2])) 
    filog.write('CHECK 1 - Triplet_B : % 10.5f % 10.5f % 10.5f \n' %(triplet_B[0],triplet_B[1],triplet_B[2])) 
    filog.write('CHECK 1 - Triplet_M : % 10.5f % 10.5f % 10.5f \n' %(triplet_M[0],triplet_M[1],triplet_M[2]))
  #
  #
  
  # From degrees to radians
  #
  angler = angle * np.pi / 180.0  
  #
  if(flag_diag == 'Y'):
    print()
    print('CHECK 2 - rotation angle (degrees) ... % 10.5f' %(angle))
    print('CHECK 2 - rotation angle (radians) ... % 10.5f' %(angler))  
    #
    filog.write('\n')
    filog.write('CHECK 2 - rotation angle (degrees) ... % 10.5f \n' %(angle))
    filog.write('CHECK 2 - rotation angle (radians) ... % 10.5f \n' %(angler))
    #
    ##########################################################################
    #
    print(                                                                    )
    print('CHECK 3 - METRIC TENSOR'                                           )
    print('CHECK 3 - % 12.5f % 12.5f % 12.5f' %(GMT[0][0],GMT[0][1],GMT[0][2]))
    print('CHECK 3 - % 12.5f % 12.5f % 12.5f' %(GMT[1][0],GMT[1][1],GMT[1][2]))
    print('CHECK 3 - % 12.5f % 12.5f % 12.5f' %(GMT[2][0],GMT[2][1],GMT[2][2]))
    print(                                                                       )
    print('CHECK 3 - RECIPROCAL METRIC TENSOR'                                   )
    print('CHECK 3 - % 12.5f % 12.5f % 12.5f' %(RGMT[0][0],RGMT[0][1],RGMT[0][2]))
    print('CHECK 3 - % 12.5f % 12.5f % 12.5f' %(RGMT[1][0],RGMT[1][1],RGMT[1][2]))
    print('CHECK 3 - % 12.5f % 12.5f % 12.5f' %(RGMT[2][0],RGMT[2][1],RGMT[2][2])) 
    #
    filog.write('                                  \n'                                 )
    filog.write('CHECK 3 - METRIC TENSOR           \n'                                 )
    filog.write('CHECK 3 - % 12.5f % 12.5f % 12.5f \n' %(GMT[0][0],GMT[0][1],GMT[0][2]))
    filog.write('CHECK 3 - % 12.5f % 12.5f % 12.5f \n' %(GMT[1][0],GMT[1][1],GMT[1][2]))
    filog.write('CHECK 3 - % 12.5f % 12.5f % 12.5f \n' %(GMT[2][0],GMT[2][1],GMT[2][2]))
    filog.write('                                  \n'                                    )
    filog.write('CHECK 3 - RECIPROCAL METRIC TENSOR\n'                                    )
    filog.write('CHECK 3 - % 12.5f % 12.5f % 12.5f \n' %(RGMT[0][0],RGMT[0][1],RGMT[0][2]))
    filog.write('CHECK 3 - % 12.5f % 12.5f % 12.5f \n' %(RGMT[1][0],RGMT[1][1],RGMT[1][2]))
    filog.write('CHECK 3 - % 12.5f % 12.5f % 12.5f \n' %(RGMT[2][0],RGMT[2][1],RGMT[2][2]))
  #
  #
  
  # AB vector
  #
  vab = np.array([ xb - xa , yb - ya , zb - za ])
  #
  xab = xb - xa
  yab = yb - ya
  zab = zb - za
  #
  if(flag_diag == 'Y'):
    print()
    print('CHECK 4 - xab = % 10.5f' %(xab))
    print('CHECK 4 - yab = % 10.5f' %(yab))
    print('CHECK 4 - zab = % 10.5f' %(zab))
    print('CHECK 4 - vector AB : % 10.5f % 10.5f % 10.5f' %(vab[0],vab[1],vab[2]))
    #
    filog.write('                                              \n'                        )
    filog.write('CHECK 4 - xab = % 10.5f \n' %(xab))
    filog.write('CHECK 4 - yab = % 10.5f \n' %(yab))
    filog.write('CHECK 4 - zab = % 10.5f \n' %(zab))
    filog.write('CHECK 4 - vector AB : % 10.5f % 10.5f % 10.5f \n' %(vab[0],vab[1],vab[2]))  
  #
  #
  
  # AB modulus
  #
  modulusab = np.sqrt(vab.dot(GMT.dot(vab)))
  #
  if(flag_diag =='Y'):
    print()
    print('CHECK 5 - vector AB modulus [in Angstroems] ... % 10.5f' %(modulusab))
    #
    filog.write('                                             \n'             )
    filog.write('CHECK 5 - vector AB modulus [in Angstroems] ... % 10.5f \n' %(modulusab))
  
  #
  #
  # Normalized AB vector
  #
  vn = (1.0/modulusab) * vab
  #
  #
  # B is used as a fixed invariant point C in the rotation
  #
  xc = xb
  yc = yb
  zc = zb
  #
  triplet_C = np.array([ xc , yc , zc ])
  #
  #
  # CM vector
  #
  vcm = np.array([ xm - xc , ym - yc , zm - zc ])
  #
  #
  # CR vector ... where R is rotated from M. CR = CR1 + CR2 + CR3
  #
  
  ##############################################
  #                                            #
  vcr1  = vcm.dot(GMT.dot(vn)) * vn
  #                                            #
  ##############################################
  
  ##############################################
  #                                            #
  vcr2 = np.cos(angler) * ( vcm - vcr1 )
  #                                            #
  ##############################################
  
  ##############################################
  #                                            #
  x1 = vn[0]
  y1 = vn[1]
  z1 = vn[2]
  #                                            #
  x2 = vcm[0]
  y2 = vcm[1]
  z2 = vcm[2]
  #                                            #
  x3 = y1 * z2 - z1 * y2
  y3 = z1 * x2 - x1 * z2
  z3 = x1 * y2 - y1 * x2
  #                                            #
  v3 = np.array([ x3 , y3 , z3 ])
  #                                            #
  ##############################################
  #                                            #
  vcr3  = volume * np.sin(angler) * v3.dot(RGMT)
  #                                            #
  ##############################################

  ##############################################
  #                                            #
  vcr = vcr1 + vcr2 + vcr3
  #                                            #
  ##############################################

  # Compute finale output triplet_R
  #
  triplet_R = triplet_C + vcr
  
  return triplet_R
#                                                                                                                       #
# END OF PART IV : FUNCTION POINT_ROTATION                                                                              #
#                                                                                                                       #
#########################################################################################################################


#
print()
#      12345678901234567890123456789012345678901234567890123456789012345678901234567890
#      1        1         2         3         4         5         6         7         8
#               0         0         0         0         0         0         0         0
print('********************************************************************************')
print()
print('***********************************************************')
print('*                                                         *')
print('* PART V : ROTATE FRAGMENT                                *')
print('*                                                         *')
print('***********************************************************')
print()
#
filog.write('\n')
filog.write('***********************************************************' + '\n')
filog.write('*                                                         *' + '\n')
filog.write('* PART V : ROTATE FRAGMENT                                *' + '\n')
filog.write('*                                                         *' + '\n')
filog.write('***********************************************************' + '\n')
filog.write('\n')
#
#########################################################################################################################
#                                                                                                                       #
# PART V : ROTATE FRAGMENT                                                                                              #
#                                                                                                                       #

print()
print('ARRAY TEST ZONE : ')
print()
# TEST ZONE
#
atom_A = np.array([ 1.0 , 2.0 , 3.0 ])
atom_B = np.array([ 4.0 , 5.0 , 6.0 ])
atom_M = np.array([ 7.0 , 8.0 , 9.0 ])
#
angle  = 0.0
#
atom_R = triplet_sum( atom_M , atom_A , atom_B )
#
print(atom_R)
  
# Firstly,  convert atom_number A into a triplet of crystallographic coordinates
#
atom_A = superatomarray[tailatomnumber-1][1:4]

# Secondly, convert atom_number B into a triplet of crystallographic coordinates
#
atom_B = superatomarray[tipatomnumber-1][1:4]

# Thirdly,  start loop over required angles
#
theta_number = 1
theta = theta_start
theta_flag = True
#
outputfilename = inputfilename_noextension
#
while((theta <= theta_stop) and (theta_flag == True)):
  #
  print()
  print()
  print(      '[ANGLE # % 3d] Current THETA = ... % 10.3f ... degrees '   %(theta_number,theta))
  #
  filog.write('\n')
  filog.write('\n')
  filog.write('[ANGLE # % 3d] Current THETA = ... % 10.3f ... degrees \n' %(theta_number,theta)) 
  #
  if(theta < 10):
    theta_ext = '.00' + str(int(theta))
  elif(theta < 100):
    theta_ext =  '.0' + str(int(theta))
  else:
    theta_ext =   '.' + str(int(theta))
  # 
  outputfilename_res = inputfilename_noextension + '_' + theta_ext[1:] + '.res'
  outputfilename_gsa = inputfilename_noextension + '_' + theta_ext[1:] + '.gsa'
  print()
  print('outputfile [.res] ===> ' + outputfilename_res)
  print('outputfile [.gsa] ===> ' + outputfilename_gsa)
  print()
  filog.write('\n')
  filog.write('outputfile [.res]  ===> ' + outputfilename_res + '\n')
  filog.write('outputfile [.gsa]  ===> ' + outputfilename_gsa + '\n')
  filog.write('\n')
  #
  filoutangle_res = open(outputfilename_res,'w')
  filoutangle_gsa = open(outputfilename_gsa,'w')
  #
  for line in headershlxfile:
    filoutangle_res.write(line)
#
# Fourthly, start loop over atoms
#
  #
  for atom_number_loop in range(1,atom_numberp1):
    print(      '[ANGLE(degrees): % 3d] Current atom number : % 3d'    %(int(theta),atom_number_loop))
    filog.write('[ANGLE(degrees): % 3d] Current atom number : % 3d \n' %(int(theta),atom_number_loop))
    #
    if atom_number_loop in movingatomlist:
      print('This atom ... MOVES !')
      filog.write('This atom ... MOVES ! \n')
      #
      atom_M = superatomarray[atom_number_loop - 1][1:4]
      atom_R = atomic_rotation( atom_M , atom_A , atom_B , theta )
      #
      print()
      print(atom_M)
      print(atom_R)
      print()
      #
      filog.write('                                          \n'                                 )
      filog.write('Before rotation : % 10.6f % 10.6f % 10.6f \n' %(atom_M[0],atom_M[1],atom_M[2]))
      filog.write('After  rotation : % 10.6f % 10.6f % 10.6f \n' %(atom_R[0],atom_R[1],atom_R[2]))
      filog.write('                                          \n'                                 )
      #
      newlinepart = '%10.6f%10.6f%10.6f'%(atom_R[0],atom_R[1],atom_R[2])
      #
      if(flag_diag == 'Y'):
        print(newlinepart)
        print()
        #
        filog.write(newlinepart+'\n')
      #
      newline_res = str(headersuperatomlist[atom_number_loop - 1]    ) + str(  tailsuperatomlist[atom_number_loop-1][:4]) + newlinepart + str( tailsuperatomlist[atom_number_loop-1][-20:-1])
      newline_res = newline_res + '\n'
    else:
      newline_res = str(headersuperatomlist[atom_number_loop - 1]) + str(tailsuperatomlist[atom_number_loop - 1])
    #
    filoutangle_res.write(newline_res)                     
    print(newline_res)
    #
    key = str(int(superatomlist[atom_number_loop - 1][0]))
    atom_type = dictionary_species[key]
    atom_type_ljust = atom_type.ljust(2)
    #
    print(key)
    print(atom_type_ljust)
    filog.write(key       + '\n')
    filog.write(atom_type_ljust + '\n')
    newline_gsa = atom_type_ljust + '  ' +newline_res
    #
    # Rearrangement of GSA line to match new GSA line format
    gsa_line_old = []
    for parameter in newline_gsa.split():
      gsa_line_old.append(parameter)
    filog.write(str(gsa_line_old) + '\n')
    #
    atom_type = gsa_line_old[0].ljust(2)
    atom_name = gsa_line_old[1].ljust(6)
    atom_specie_shlx = gsa_line_old[2]
    atom_x           = gsa_line_old[3]
    atom_y           = gsa_line_old[4]
    atom_z           = gsa_line_old[5]
    osf              = gsa_line_old[6]
    uiso             = gsa_line_old[7]
    #
    atom_x_f = float(atom_x)
    atom_y_f = float(atom_y)
    atom_z_f = float(atom_z)
    osf_f    = float(osf)
    uiso_f   = float(uiso)
    #
    # Na ===> NA etc...
    if ord(atom_type[1])>90:
      ord_new = ord(atom_type[1]) - 32
      atom_type_new = chr(ord_new)
      print(atom_type_new)
      atom_type = atom_type[0] + atom_type_new
      print(atom_type)
    #
    filog.write('atom type          : ' + atom_type        + '\n')
    filog.write('atom name          : ' + atom_name        + '\n')
    filog.write('atom specie [shlx] : ' + atom_specie_shlx + '\n')
    filog.write('atom x             : ' + atom_x           + '\n')
    filog.write('atom y             : ' + atom_y           + '\n')
    filog.write('atom z             : ' + atom_z           + '\n')
    filog.write('osf                : ' + osf              + '\n')
    filog.write('uiso               : ' + uiso             + '\n')
    filog.write(                                             '\n')
    #
    # filoutangle_gsa.write(newline_gsa)                               # obsolete as of 2021-03-07
    filoutangle_gsa.write('%2s%10.6f%10.6f%10.6f%10.6f%1s%6s%9.6f\n' %(atom_type,atom_x_f,atom_y_f,atom_z_f,osf_f,spacer,atom_name,uiso_f))
    #                        1     2     3     4     5  6  7    8              1        2        3        4     5      6         7      8
    filog.write('[ SHLX RES : ]' + '        ' + newline_res       )
    # filog.write('[ GSAS GSA : ]' + '    '     + newline_gsa + '\n')  # obsolete as of 2021-03-07
    filog.write('[ GSAS GSA : ]' + '        ' + '%2s%10.6f%10.6f%10.6f%10.6f%1s%6s%9.6f\n' %(atom_type,atom_x_f,atom_y_f,atom_z_f,osf_f,spacer,atom_name,uiso_f))
    filog.write('\n')
    filog.write('\n')
    #
    # atom_number_loop = atom_number_loop + 1
    #
  print()
#
# Fourthly, stop loop over atoms
#                            1         2         3         4         5         6         7         8
#                   12345678901234567890123456789012345678901234567890123456789012345678901234567890
  line_separator = '================================================================================'
  filog.write(                 '\n')
  filog.write(line_separator + '\n')
#
  filoutangle_res.write('END' + '\n')
  filoutangle_res.close()
  #
  filoutangle_gsa.close()                       
  #
  # Upon exiting the while-atom loop
  if(theta_step!=0.0):
    theta = theta + theta_step
    theta_number = theta_number + 1
  else:
    theta_flag = False
#
print()
print('All is well that ends well ... ')
print()

  
#                                                                                                                       #
# END OF PART V : ROTATE FRAGMENT                                                                                       #
#                                                                                                                       #
#########################################################################################################################


# BACK-END HEADER
print()
print(' ************************************************************************************* ')
print(' *                                                                                   * ')
print(' * THANK YOU ... for using our software ... ROTATE_FRAGMENT ... [v 163 - 2021-03-07] * ')
print(' *                                                                                   * ')
print(' ************************************************************************************* ')
print(' *                                                                                   * ')
print(' *     Written by ... Robert J PAPOULAR ... [IRAMIS, DRF , CEA-Saclay , France]      * ')
print(' *                                                                                   * ')
print(' ************************************************************************************* ')
print(' *                                                                                   * ')
print(' *                              Robert.Papoular@cea.fr                               * ')
print(' *                                                                                   * ')
print(' ************************************************************************************* ')
print()
#
filog.write(                                                                                            '\n')
filog.write(' ************************************************************************************* ' + '\n')
filog.write(' *                                                                                   * ' + '\n')
filog.write(' * THANK YOU ... for using our software ... ROTATE_FRAGMENT ... [v 163 - 2021-03-07] * ' + '\n')
filog.write(' *                                                                                   * ' + '\n')
filog.write(' ************************************************************************************* ' + '\n')
filog.write(' *                                                                                   * ' + '\n')
filog.write(' *     Written by ... Robert J PAPOULAR ... [IRAMIS, DRF , CEA-Saclay , France]      * ' + '\n')
filog.write(' *                                                                                   * ' + '\n')
filog.write(' ************************************************************************************* ' + '\n')
filog.write(' *                                                                                   * ' + '\n')
filog.write(' *                              Robert.Papoular@cea.fr                               * ' + '\n')
filog.write(' *                                                                                   * ' + '\n')
filog.write(' ************************************************************************************* ' + '\n')
filog.write(                                                                                            '\n')
#
#
# SET DATE AND TIME
stoptime = str(datetime.datetime.now())[:19]  # truncated after 20 characters ...
print()
print(stoptime)
print()
#
filog.write(           '\n')
filog.write(stoptime + '\n')
filog.write(           '\n')
#
#
# CLOSE LOGICAL FILES
#
filog.close()   
#

